#include<bits/stdc++.h>
using namespace std;
const int N=5e5+5;
int n,q,dep[N],st[N][20],ma[N][20];
vector<int>v[N];
int lca(int x,int y){
	if(!x)return y;
	if(!y)return x;
	if(dep[x]<dep[y])swap(x,y);
	for(int i=18;i>=0;i--){
		if(dep[st[x][i]]>=dep[y]){
			x=st[x][i];
		}
	}
	if(x==y)return x;
	for(int i=18;i>=0;i--){
		if(st[x][i]!=st[y][i]){
			x=st[x][i];
			y=st[y][i];
		}
	}
	return st[x][0];
}
void dfs(int x,int fa){
	dep[x]=dep[fa]+1;
	st[x][0]=fa;
	for(int i=1;i<=18;i++){
		st[x][i]=st[st[x][i-1]][i-1];
	}
	for(int y:v[x]){
		if(y==fa)continue;
		dfs(y,x);
	}
}
int main(){
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	scanf("%d",&n);
	for(int i=1,x,y;i<n;i++){
		scanf("%d %d",&x,&y);
		v[x].push_back(y);
		v[y].push_back(x);
	}
	dfs(1,0);
	for(int i=n;i>=1;i--){
		ma[i][0]=i;
		for(int j=1;j<=18;j++){
			int len=1<<(j-1);
			ma[i][j]=lca(ma[i][j-1],(i+len<=n)?ma[i+len][j-1]:0);
		}
	}
	scanf("%d",&q);
	for(int i=1,x,y,z;i<=q;i++){
		scanf("%d %d %d",&x,&y,&z);
		int k=log2(z),ans=0,len=1<<k;
		for(int j=x;j+z-1<=y;j++){
			ans=max(ans,dep[lca(ma[j][k],ma[j+z-len][k])]);
		}
		printf("%d\n",ans);
	} 
	return 0;
}
